OGRE: Ogre::GpuSharedParameters Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::GpuSharedParameters Class Reference
Core » Materials

A group of manually updated parameters that are shared between many parameter sets. More...

`#include <OgreGpuProgramParams.h>`

Inheritance diagram for Ogre::GpuSharedParameters:
[legend]

## Public Member Functions
| GpuSharedParameters (const String &name)
const HardwareBufferPtr & | _getHardwareBuffer () const
| Internal method that the RenderSystem might use to store optional data.
void | _markClean ()
| Mark the shared set as being clean (values successfully updated by the render system).
void | _markDirty ()
| Mark the shared set as being dirty (values modified and not yet updated in render system).
void | _setHardwareBuffer (const HardwareBufferPtr &data)
| Internal method that the RenderSystem might use to store optional data.
void | _upload () const
| upload parameter data to GPU memory. Must have a HardwareBuffer
void | addConstantDefinition (const String &name, GpuConstantType constType, uint32 arraySize=1)
| Add a new constant definition to this shared set of parameters.
size_t | calculateSize (void) const
| Calculate the expected size of the shared parameter buffer based on constant definition data types.
void | download ()
| download data from GPU memory. Must have a writable HardwareBuffer
const GpuConstantDefinition & | getConstantDefinition (const String &name) const
| Get a specific GpuConstantDefinition for a named parameter.
GpuConstantDefinitionIterator | getConstantDefinitionIterator (void) const
const GpuNamedConstants & | getConstantDefinitions () const
| Get the full list of GpuConstantDefinition instances.
const ConstantList & | getConstantList () const
| Get a reference to the list of constants.
double * | getDoublePointer (size_t pos)
| Get a pointer to the 'nth' item in the double buffer.
const double * | getDoublePointer (size_t pos) const
| Get a pointer to the 'nth' item in the double buffer.
float * | getFloatPointer (size_t pos)
| Get a pointer to the 'nth' item in the float buffer.
const float * | getFloatPointer (size_t pos) const
| Get a pointer to the 'nth' item in the float buffer.
int * | getIntPointer (size_t pos)
| Get a pointer to the 'nth' item in the int buffer.
const int * | getIntPointer (size_t pos) const
| Get a pointer to the 'nth' item in the int buffer.
const String & | getName ()
| Get the name of this shared parameter set.
uint * | getUnsignedIntPointer (size_t pos)
| Get a pointer to the 'nth' item in the uint buffer.
const uint * | getUnsignedIntPointer (size_t pos) const
| Get a pointer to the 'nth' item in the uint buffer.
uint32 | getVersion () const
| Get the version number of this shared parameter set, can be used to identify when changes have occurred.
bool | isDirty () const
| True if this parameter set is dirty (values have been modified, but the render system has not updated them yet).
void | removeAllConstantDefinitions ()
| Remove a constant definition from this shared set of parameters.
void | removeConstantDefinition (const String &name)
void | setNamedConstant (const String &name, const ColourValue &colour)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setNamedConstant (const String &name, const double *val, uint32 count)
void | setNamedConstant (const String &name, const float *val, uint32 count)
void | setNamedConstant (const String &name, const int *val, uint32 count)
void | setNamedConstant (const String &name, const Matrix4 &m)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setNamedConstant (const String &name, const Matrix4 *m, uint32 numEntries)
| Sets a list of Matrix4 parameters to the program.
void | setNamedConstant (const String &name, const uint *val, uint32 count)
template<int dims, typename T>
void | setNamedConstant (const String &name, const Vector< dims, T > &vec)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<typename T>
void | setNamedConstant (const String &name, T val)
| Sets a single value constant parameter to the program.

## Detailed Description

A group of manually updated parameters that are shared between many parameter sets.

Sometimes you want to set some common parameters across many otherwise different parameter sets, and keep them all in sync together. This class allows you to define a set of parameters that you can share across many parameter sets and have the parameters that match automatically be pulled from the shared set, rather than you having to set them on all the parameter sets individually.

  Parameters in a shared set are matched up with instances in a GpuProgramParameters structure by matching names. It is up to you to define the named parameters that a shared set contains, and ensuring the definition matches.

Note
  Shared parameter sets can be named, and looked up using the GpuProgramManager.

## Constructor & Destructor Documentation

## ◆ GpuSharedParameters()

Ogre::GpuSharedParameters::GpuSharedParameters | ( | const String & | name | ) |

## Member Function Documentation

## ◆ getName()

const String & Ogre::GpuSharedParameters::getName | ( |  | ) |
| inline

Get the name of this shared parameter set.

## ◆ addConstantDefinition()

void Ogre::GpuSharedParameters::addConstantDefinition | ( | const String & | name,
|  | GpuConstantType | constType,
|  | uint32 | arraySize = 1 )

Add a new constant definition to this shared set of parameters.

Unlike GpuProgramParameters, where the parameter list is defined by the program being compiled, this shared parameter set is defined by the user. Only parameters which have been predefined here may be later updated.

## ◆ removeConstantDefinition()

void Ogre::GpuSharedParameters::removeConstantDefinition | ( | const String & | name | ) |

Deprecated
  removing a constant requires a full rebuild due to changed alignments

## ◆ removeAllConstantDefinitions()

void Ogre::GpuSharedParameters::removeAllConstantDefinitions | ( |  | ) |

Remove a constant definition from this shared set of parameters.

## ◆ getVersion()

uint32 Ogre::GpuSharedParameters::getVersion | ( |  | ) | const
| inline

Get the version number of this shared parameter set, can be used to identify when changes have occurred.

## ◆ calculateSize()

size_t Ogre::GpuSharedParameters::calculateSize | ( | void |  | ) | const

Calculate the expected size of the shared parameter buffer based on constant definition data types.

## ◆ isDirty()

bool Ogre::GpuSharedParameters::isDirty | ( |  | ) | const
| inline

True if this parameter set is dirty (values have been modified, but the render system has not updated them yet).

## ◆ _markClean()

void Ogre::GpuSharedParameters::_markClean | ( |  | ) |

Mark the shared set as being clean (values successfully updated by the render system).

You do not need to call this yourself. The set is marked as clean whenever the render system updates dirty shared parameters.

## ◆ _markDirty()

void Ogre::GpuSharedParameters::_markDirty | ( |  | ) |

Mark the shared set as being dirty (values modified and not yet updated in render system).

You do not need to call this yourself. The set is marked as dirty whenever setNamedConstant or (non const) getFloatPointer et al are called.

Referenced by getDoublePointer(), getFloatPointer(), getIntPointer(), and getUnsignedIntPointer().

## ◆ getConstantDefinitionIterator()

GpuConstantDefinitionIterator Ogre::GpuSharedParameters::getConstantDefinitionIterator | ( | void |  | ) | const

Deprecated
  use getConstantDefinitions()

## ◆ getConstantDefinition()

const GpuConstantDefinition & Ogre::GpuSharedParameters::getConstantDefinition | ( | const String & | name | ) | const

Get a specific GpuConstantDefinition for a named parameter.

## ◆ getConstantDefinitions()

const GpuNamedConstants & Ogre::GpuSharedParameters::getConstantDefinitions | ( |  | ) | const

Get the full list of GpuConstantDefinition instances.

## ◆ setNamedConstant() [1/9]

template<typename T>

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | T | val )
| inline

Sets a single value constant parameter to the program.

Different types of GPU programs support different types of constant parameters. For example, it's relatively common to find that vertex programs only support floating point constants, and that fragment programs only support integer (fixed point) parameters. This can vary depending on the program version supported by the graphics card being used. You should consult the documentation for the type of low level program you are using, or alternatively use the methods provided on RenderSystemCapabilities to determine the options.

Another possible limitation is that some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. Again, see RenderSystemCapabilities for full details.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | The value to set

References setNamedConstant().

Referenced by setNamedConstant(), and setNamedConstant().

## ◆ setNamedConstant() [2/9]

template<int dims, typename T>

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | const Vector< dims, T > & | vec )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::VectorBase< dims, T >::ptr(), and setNamedConstant().

## ◆ setNamedConstant() [3/9]

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | const Matrix4 & | m )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ setNamedConstant() [4/9]

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | const Matrix4 * | m,
|  | uint32 | numEntries )

Sets a list of Matrix4 parameters to the program.

Parameters

  name | The name of the parameter; this must be the first index of an array, for examples 'matrices[0]' NB since a Matrix4 is 16 floats long, so each entry will take up 4 indexes.
  m | Pointer to an array of matrices to set
  numEntries | Number of Matrix4 entries

## ◆ setNamedConstant() [5/9]

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | const float * | val,
|  | uint32 | count )

## ◆ setNamedConstant() [6/9]

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | const double * | val,
|  | uint32 | count )

## ◆ setNamedConstant() [7/9]

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | const ColourValue & | colour )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ setNamedConstant() [8/9]

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | const int * | val,
|  | uint32 | count )

## ◆ setNamedConstant() [9/9]

void Ogre::GpuSharedParameters::setNamedConstant | ( | const String & | name,
|  | const uint * | val,
|  | uint32 | count )

## ◆ getFloatPointer() [1/2]

float * Ogre::GpuSharedParameters::getFloatPointer | ( | size_t | pos | ) |
| inline

Get a pointer to the 'nth' item in the float buffer.

References _markDirty().

## ◆ getFloatPointer() [2/2]

const float * Ogre::GpuSharedParameters::getFloatPointer | ( | size_t | pos | ) | const
| inline

Get a pointer to the 'nth' item in the float buffer.

## ◆ getDoublePointer() [1/2]

double * Ogre::GpuSharedParameters::getDoublePointer | ( | size_t | pos | ) |
| inline

Get a pointer to the 'nth' item in the double buffer.

References _markDirty().

## ◆ getDoublePointer() [2/2]

const double * Ogre::GpuSharedParameters::getDoublePointer | ( | size_t | pos | ) | const
| inline

Get a pointer to the 'nth' item in the double buffer.

## ◆ getIntPointer() [1/2]

int * Ogre::GpuSharedParameters::getIntPointer | ( | size_t | pos | ) |
| inline

Get a pointer to the 'nth' item in the int buffer.

References _markDirty().

## ◆ getIntPointer() [2/2]

const int * Ogre::GpuSharedParameters::getIntPointer | ( | size_t | pos | ) | const
| inline

Get a pointer to the 'nth' item in the int buffer.

## ◆ getUnsignedIntPointer() [1/2]

uint * Ogre::GpuSharedParameters::getUnsignedIntPointer | ( | size_t | pos | ) |
| inline

Get a pointer to the 'nth' item in the uint buffer.

References _markDirty().

## ◆ getUnsignedIntPointer() [2/2]

const uint * Ogre::GpuSharedParameters::getUnsignedIntPointer | ( | size_t | pos | ) | const
| inline

Get a pointer to the 'nth' item in the uint buffer.

## ◆ getConstantList()

const ConstantList & Ogre::GpuSharedParameters::getConstantList | ( |  | ) | const
| inline

Get a reference to the list of constants.

## ◆ _setHardwareBuffer()

void Ogre::GpuSharedParameters::_setHardwareBuffer | ( | const HardwareBufferPtr & | data | ) |
| inline

Internal method that the RenderSystem might use to store optional data.

## ◆ _getHardwareBuffer()

const HardwareBufferPtr & Ogre::GpuSharedParameters::_getHardwareBuffer | ( |  | ) | const
| inline

Internal method that the RenderSystem might use to store optional data.

## ◆ _upload()

void Ogre::GpuSharedParameters::_upload | ( |  | ) | const

upload parameter data to GPU memory. Must have a HardwareBuffer

## ◆ download()

void Ogre::GpuSharedParameters::download | ( |  | ) |

download data from GPU memory. Must have a writable HardwareBuffer

The documentation for this class was generated from the following file:

- OgreGpuProgramParams.h